;KTs TimeTabler
;Site Functions

Function GetFileName$(file$)
	txt$ = file$
	Repeat
		txt$ = Mid$(txt$, Instr(txt$, "\") + 1, -1)
	Until Instr(txt$, "\") = False
	Return txt$
End Function

Function IsLineBreak(filestream)
	If ReadLine(filestream) = "" Return True
End Function

Function GetWeekDay$(name = False, date$ = "", day = 0, month = 0, year = 0)
	If date$ <> ""
		dot1 = Instr(date$, ".")
		dot2 = Instr(date$, ".", dot1 + 1)
		d = Mid$(date$, 1, dot1 - 1)
		m = Mid$(date$, dot1 + 1, dot2 - 1)
		yh = Mid$(date$, dot2 + 1, -1)
	ElseIf day <> False
		d = day
		m = month
		yh = year
		date$ = d + "." + m + "." + y
	Else
		d = Left$(CurrentDate$(), 2)
		Select Mid$(CurrentDate$(), 4, 3)
			Case "Jan"
				m = 01
			Case "Feb"
				m = 02
			Case "Mar"
				m = 03
			Case "Apr"
				m = 04
			Case "May"
				m = 05
			Case "Jun"
				m = 06
			Case "Jul"
				m = 07
			Case "Aug"
				m = 08
			Case "Sep"
				m = 09
			Case "Okt"
				m = 10
			Case "Nov"
				m = 11
			Case "Dec"
				m = 12
		End Select
		yh = Right$(CurrentDate$(), 4)
	EndIf
	
	y = yh Mod 100
	yh = Int (yh / 100) 
	
	
	If m < 3 Then 
		m = m + 12 
		If y = 0 Then 
			y = 99
			If yh = 0 Then yh = 0 Else yh = yh - 1 
		Else
			y = y - 1 
		EndIf 
	EndIf 	
	
	
	wd = d + Int((m + 1) * 26 / 10)
	wd = wd + Int(5 * y / 4) + Int(yh / 4)
	wd = wd - (2 * yh) - 1 
	wd = wd Mod 7
	
	If Not name
		If wd = 0 wd = 7
		Return wd
	Else
		Select wd 
			Case 0
				ret$ = "Sonntag"
			Case 1
				ret$ = "Montag"
			Case 2
				ret$ = "Dienstag"
			Case 3
				ret$ = "Mittwoch"
			Case 4 
				ret$ = "Donnerstag"
			Case 5
				ret$ = "Freitag"
			Case 6
				ret$ = "Samstag"
		End Select
	EndIf
	Select name
		Case 1
			ret$ = ret$
		Case 2
			Select ret$
				Case "Montag"
					ret$ = "Mo"
				Case "Dienstag"
					ret$ = "Di"
				Case "Mittwoch"
					ret$ = "Mi"
				Case "Donnerstag"
					ret$ = "Do"
				Case "Freitag"
					ret$ = "Fr"
				Case "Samstag"
					ret$ = "Sa"
				Case "Sonntag"
					ret$ = "So"
			End Select
		Case 3
			Select ret$
				Case "Montag"
					ret$ = "Monday"
				Case "Dienstag"
					ret$ = "Tuesday"
				Case "Mittwoch"
					ret$ = "Wednesday"
				Case "Donnerstag"
					ret$ = "Thursday
				Case "Freitag"
					ret$ = "Friday"
				Case "Samstag"
					ret$ = "Saturday"
				Case "Sonntag"
					ret$ = "Sunday"
			End Select
		Case 4
			Select ret$
				Case "Montag"
					ret$ = "Mo"
				Case "Dienstag"
					ret$ = "Tu"
				Case "Mittwoch"
					ret$ = "We"
				Case "Donnerstag"
					ret$ = "Th"
				Case "Freitag"
					ret$ = "Fr"
				Case "Samstag"
					ret$ = "Sa"
				Case "Sonntag"
					ret$ = "Su"
			End Select
	End Select
	Return ret$
End Function

Function GetTaskBarInfo(info)
	;info: =1 shape, =2 pos;, =4 showed
	rectangle = CreateBank(16)
	SystemParametersInfo($0030, 0, rectangle, 0)
	x = PeekInt(rectangle, 0)
	y = PeekInt(rectangle, 4)
	x2 = PeekInt(rectangle, 8)
	y2 = PeekInt(rectangle, 12)
	If x <> 0 pos = 1
	If y <> 0 pos = 2
	If x2 <> GadgetWidth(Desktop()) pos = 3
	If y2 <> GadgetHeight(Desktop()) pos = 4
	If info = 2 Return pos
	If pos = 1 ret_sh = x
	If pos = 2 ret_sh = y
	If pos = 3 ret_sh = GadgetWidth(Desktop()) - x2
	If pos = 4 ret_sh = GadgetHeight(Desktop()) - y2
	Return ret_sh
End Function

Function GetProgramPath$()
	lpFileName = CreateBank(256) 
	str_len = GetModuleFileName(0, lpFileName, BankSize(lpFileName)) 
	If str_len <= 0 Return "!ERROR!"
	For grab_exe_name = 0 To str_len-1 
   		exe_name$ = exe_name + Chr(PeekByte(lpFileName, grab_exe_name)) 
	Next 
	exe_name$ = Right$(exe_name$, Len(GetFileName$(exe_name$)))
	Return exe_name$
End Function

Function GetExcutePath$()
	lpFileName = CreateBank(256) 
	str_len = GetModuleFileName(0, lpFileName, BankSize(lpFileName)) 
	If str_len <= 0 Return "!ERROR!"
	For grab_exe_name = 0 To str_len-1 
   		exe_name$ = exe_name + Chr(PeekByte(lpFileName, grab_exe_name)) 
	Next 
	Return exe_name$
End Function

Function AddWindowMinimizeButton(window = 0)
;	Stop
	
	If window = 0 Then
		window_hwnd = api_GetForegroundWindow()
	Else
		window_hwnd = QueryObject(window, 1)
	EndIf
	window_oldstyle= api_GetWindowLong(window_hwnd, (-16))
	api_SetWindowLong(window_hwnd, -16, window_oldstyle Or $00020000)
	If window Then
		HideGadget window
		ShowGadget window
	Else
		api_ShowWindow(window_hwnd,SW_HIDE)
		api_ShowWindow(window_hwnd,SW_SHOWNORMAL)
	EndIf
	Return api_GetWindowLong(window_hwnd, (-16));window_oldstyle;
End Function